# class IO::Memory

- IO::Memory
- IO
- Reference
- Object

##
Overview

An `IO` that reads and writes from a buffer in memory.

The internal buffer can be resizeable and/or writeable depending on how an `IO::Memory` is constructed.

##
Defined in:

##
Constructors

- .new(capacity : Int = 64)

  Creates an empty, resizeable and writeable `IO::Memory` with the given initial capacity for the internal buffer.

- .new(string : String)

  Creates an `IO::Memory` whose contents are the exact contents of string.

- .new(slice : Bytes, writeable = true)

  Creates an `IO::Memory` that will read, and optionally write, from/to the given slice.

##
Instance Method Summary

- #buffer : Pointer(UInt8)

  Returns the internal buffer as a `Pointer(UInt8)`.

- #bytesize : Int32

  Same as `#size`.

- #clear

  Clears the internal buffer and resets the position to zero.

- #close

  Closes this `IO`.

- #closed? : Bool

  Determines if this `IO` is closed.

- #empty?

  Returns `true` if this `IO::Memory` has no contents.

- #pos : Int32

  Returns the current position (in bytes) of this `IO`.

- #pos=(value)

  Sets the current position (in bytes) of this `IO`.

- #read(slice : Bytes)

  See `IO#read(slice)`.

- #read_at(offset, bytesize, &)

  Yields an `IO::Memory` to read a section of this `IO`'s buffer.

- #rewind

  Rewinds this `IO` to the initial position (zero).

- #seek(offset, whence : Seek = Seek::Set)

  Seeks to a given offset (in bytes) according to the whence argument.

- #size : Int32

  Returns the total number of bytes in this `IO`.

- #to_s(io : IO) : Nil

  Appends this internal buffer to the given `IO`.

- #to_s : String

  Returns a new `String` that contains the contents of the internal buffer.

- #to_slice : Bytes

  Returns the underlying bytes.

- #write(slice : Bytes) : Nil

  See `IO#write(slice)`.

- #write_byte(byte : UInt8)

  See `IO#write_byte`.

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, gets(delimiter : Char, limit : Int, chomp = false) : String?
gets(delimiter : Char, chomp = false) : String?
gets(chomp = true) : String?
gets(limit : Int, chomp = false) : String?
gets(delimiter : String, chomp = false) : String? gets, gets_to_end : String gets_to_end, peek : Bytes? peek, pos pos, pos=(value) pos=, print(*objects : _) : Nil
print(obj) : Nil print, printf(format_string, *args) : Nil
printf(format_string, args : Array | Tuple) : Nil printf, puts(*objects : _) : Nil
puts : Nil
puts(obj) : Nil
puts(string : String) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, &) read_at, read_byte : UInt8? read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char? read_char, read_fully(slice : Bytes) read_fully, read_fully?(slice : Bytes) read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol? = nil) set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) write_bytes, write_utf8(slice : Bytes) write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : UInt64
copy(src, dst) : UInt64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(capacity : Int = 64) #

Creates an empty, resizeable and writeable `IO::Memory` with the given initial capacity for the internal buffer.

    io = IO::Memory.new
    slice = Bytes.new(1)
    io.pos         # => 0
    io.read(slice) # => 0
    slice          # => Bytes[0]

def self.new(string : String) #

Creates an `IO::Memory` whose contents are the exact contents of string. The created `IO::Memory` is non-resizeable and non-writeable.

The `IO` starts at position zero for reading.

    io = IO::Memory.new "hello"
    io.pos        # => 0
    io.gets(2)    # => "he"
    io.print "hi" # raises IO::Error

def self.new(slice : Bytes, writeable = true) #

Creates an `IO::Memory` that will read, and optionally write, from/to the given slice. The created `IO::Memory` is non-resizeable.

The IO starts at position zero for reading.

    slice = Slice.new(6) { |i| ('a'.ord + i).to_u8 }
    io = IO::Memory.new slice, writeable: false
    io.pos            # => 0
    io.read(slice)    # => 6
    String.new(slice) # => "abcdef"

##
Instance Method Detail

def buffer : Pointer(UInt8) #

Returns the internal buffer as a `Pointer(UInt8)`.

def bytesize : Int32 #

Same as `#size`.

def clear #

Clears the internal buffer and resets the position to zero. Raises if this `IO::Memory` is non-resizeable.

    io = IO::Memory.new
    io << "abc"
    io.rewind
    io.gets(1) # => "a"
    io.clear
    io.pos         # => 0
    io.gets_to_end # => ""

    io = IO::Memory.new "hello"
    io.clear # raises IO::Error

def close #

Closes this `IO`. Further operations on this `IO` will raise an `IO::Error`.

    io = IO::Memory.new "hello"
    io.close
    io.gets_to_end # raises IO::Error (closed stream)

def closed? : Bool #

Determines if this `IO` is closed.

    io = IO::Memory.new "hello"
    io.closed? # => false
    io.close
    io.closed? # => true

def empty? #

Returns `true` if this `IO::Memory` has no contents.

    io = IO::Memory.new
    io.empty? # => true
    io.print "hello"
    io.empty? # => false

def pos : Int32 #

Returns the current position (in bytes) of this `IO`.

    io = IO::Memory.new "hello"
    io.pos     # => 0
    io.gets(2) # => "he"
    io.pos     # => 2

def pos=(value) #

Sets the current position (in bytes) of this `IO`.

    io = IO::Memory.new "hello"
    io.pos = 3
    io.gets # => "lo"

def read(slice : Bytes) #

See `IO#read(slice)`.

def read_at(offset, bytesize, &) #

Yields an `IO::Memory` to read a section of this `IO`'s buffer.

During the block duration `self` becomes read-only, so multiple concurrent open are allowed.

def rewind #

Rewinds this `IO` to the initial position (zero).

    io = IO::Memory.new "hello"
    io.gets(2) # => "he"
    io.rewind
    io.gets(2) # => "he"

def seek(offset, whence : Seek = Seek::Set) #

Seeks to a given offset (in bytes) according to the whence argument.

    io = IO::Memory.new("abcdef")
    io.gets(3) # => "abc"
    io.seek(1, IO::Seek::Set)
    io.gets(2) # => "bc"
    io.seek(-1, IO::Seek::Current)
    io.gets(1) # => "c"

def size : Int32 #

Returns the total number of bytes in this `IO`.

    io = IO::Memory.new "hello"
    io.size # => 5

def to_s(io : IO) : Nil #

Appends this internal buffer to the given `IO`.

def to_s : String #

Returns a new `String` that contains the contents of the internal buffer.

    io = IO::Memory.new
    io.print 1, 2, 3
    io.to_s # => "123"

def to_slice : Bytes #

Returns the underlying bytes.

    io = IO::Memory.new
    io.print "hello"

    io.to_slice # => Bytes[104, 101, 108, 108, 111]

def write(slice : Bytes) : Nil #

See `IO#write(slice)`. Raises if this `IO::Memory` is non-writeable, or if it's non-resizeable and a resize is needed.

def write_byte(byte : UInt8) #

See `IO#write_byte`. Raises if this `IO::Memory` is non-writeable, or if it's non-resizeable and a resize is needed.